Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 15847)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 15848)
@@ -432,4 +432,10 @@
       <DependentUpon>RegressionSolutionScatterPlotView.cs</DependentUpon>
     </Compile>
+    <Compile Include="Regression\TransformedRegressionModelView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Regression\TransformedRegressionModelView.Designer.cs">
+      <DependentUpon>TransformedRegressionModelView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Solution Views\ClassificationSolutionView.cs">
       <SubType>UserControl</SubType>
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/TransformedRegressionModelView.Designer.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/TransformedRegressionModelView.Designer.cs	(revision 15848)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/TransformedRegressionModelView.Designer.cs	(revision 15848)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.DataAnalysis.Views {
+  partial class TransformedRegressionModelView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.tabPageModel = new System.Windows.Forms.TabPage();
+      this.tabPageTransformations = new System.Windows.Forms.TabPage();
+      this.modelViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.transformationsViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.tabControl.SuspendLayout();
+      this.tabPageModel.SuspendLayout();
+      this.tabPageTransformations.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // tabControl
+      // 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.tabPageModel);
+      this.tabControl.Controls.Add(this.tabPageTransformations);
+      this.tabControl.Location = new System.Drawing.Point(3, 3);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(494, 418);
+      this.tabControl.TabIndex = 0;
+      // 
+      // tabPageModel
+      // 
+      this.tabPageModel.Controls.Add(this.modelViewHost);
+      this.tabPageModel.Location = new System.Drawing.Point(4, 22);
+      this.tabPageModel.Name = "tabPageModel";
+      this.tabPageModel.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPageModel.Size = new System.Drawing.Size(486, 392);
+      this.tabPageModel.TabIndex = 0;
+      this.tabPageModel.Text = "Original Model";
+      this.tabPageModel.UseVisualStyleBackColor = true;
+      // 
+      // tabPageTransformations
+      // 
+      this.tabPageTransformations.Controls.Add(this.transformationsViewHost);
+      this.tabPageTransformations.Location = new System.Drawing.Point(4, 22);
+      this.tabPageTransformations.Name = "tabPageTransformations";
+      this.tabPageTransformations.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPageTransformations.Size = new System.Drawing.Size(486, 392);
+      this.tabPageTransformations.TabIndex = 1;
+      this.tabPageTransformations.Text = "Transformations";
+      this.tabPageTransformations.UseVisualStyleBackColor = true;
+      // 
+      // modelViewHost
+      // 
+      this.modelViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.modelViewHost.Location = new System.Drawing.Point(3, 3);
+      this.modelViewHost.Name = "modelViewHost";
+      this.modelViewHost.Size = new System.Drawing.Size(480, 386);
+      this.modelViewHost.TabIndex = 0;
+      // 
+      // transformationsViewHost
+      // 
+      this.transformationsViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.transformationsViewHost.Location = new System.Drawing.Point(3, 3);
+      this.transformationsViewHost.Name = "transformationsViewHost";
+      this.transformationsViewHost.Size = new System.Drawing.Size(480, 386);
+      this.transformationsViewHost.TabIndex = 0;
+      // 
+      // TransformedRegressionModelView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tabControl);
+      this.Name = "TransformedRegressionModelView";
+      this.Size = new System.Drawing.Size(500, 424);
+      this.tabControl.ResumeLayout(false);
+      this.tabPageModel.ResumeLayout(false);
+      this.tabPageTransformations.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage tabPageModel;
+    private System.Windows.Forms.TabPage tabPageTransformations;
+    private HeuristicLab.MainForm.WindowsForms.ViewHost modelViewHost;
+    private HeuristicLab.MainForm.WindowsForms.ViewHost transformationsViewHost;
+  }
+}
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/TransformedRegressionModelView.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/TransformedRegressionModelView.cs	(revision 15848)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/TransformedRegressionModelView.cs	(revision 15848)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion            
+
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Problems.DataAnalysis.Views {
+  [View("Transformed regression model")]
+  [Content(typeof(ITransformedRegressionModel), true)]
+  public partial class TransformedRegressionModelView : ItemView {
+
+    public new ITransformedRegressionModel Content {
+      get { return (ITransformedRegressionModel)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public TransformedRegressionModelView() {
+      InitializeComponent();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      modelViewHost.Content = Content?.OriginalModel;
+      transformationsViewHost.Content = Content?.Transformations;
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      tabControl.Enabled = Content != null;
+    }
+  }
+}
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs	(revision 15847)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/DataAnalysisProblemData.cs	(revision 15848)
@@ -273,8 +273,10 @@
     }
 
-    public static IDataset InverseTransform(IDataset dataset, IEnumerable<IDataAnalysisTransformation> transformations) {
+    public static IDataset InverseTransform(IDataset dataset, IEnumerable<IDataAnalysisTransformation> transformations, bool removeVirtualVariables = true) {
       var modifiableDataset = ((Dataset)dataset).ToModifiable();
 
-      foreach (var transformation in transformations.Reverse()) {
+      var transformationsStack = new Stack<IDataAnalysisTransformation>(transformations);
+      while (transformationsStack.Any()) {
+        var transformation = transformationsStack.Pop();
         var trans = (ITransformation<double>)transformation.Transformation;
 
@@ -283,4 +285,8 @@
         var originalData = trans.InverseApply(transformedData).ToList();
         modifiableDataset.ReplaceVariable(transformation.OriginalVariable, originalData);
+
+        bool transformedVariablePending = transformationsStack.Any(x => x.OriginalVariable == transformation.TransformedVariable);
+        if (removeVirtualVariables && !transformedVariablePending)
+          modifiableDataset.RemoveVariable(transformation.TransformedVariable);
       }
 
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/ITransformedRegressionModel.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/ITransformedRegressionModel.cs	(revision 15847)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/ITransformedRegressionModel.cs	(revision 15848)
@@ -20,7 +20,12 @@
 #endregion
 
+using HeuristicLab.Core;
+
 namespace HeuristicLab.Problems.DataAnalysis {
   public interface ITransformedRegressionModel : IRegressionModel {
+
     IRegressionModel OriginalModel { get; }
+
+    ItemList<IDataAnalysisTransformation> Transformations { get; }
   }
 }