Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF1 : ResourceRegressionDataDescriptor {
+    public CF1(string resourceName) : base(resourceName) { }
     public override string Name { get { return "CF1"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF2 : ResourceRegressionDataDescriptor {
+    public CF2(string resourceName) : base(resourceName) { }
     public override string Name { get { return "CF2"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF3 : ResourceRegressionDataDescriptor {
+    public CF3(string resourceName) : base(resourceName) { }
     public override string Name { get { return "CF3"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class CF4 : ResourceRegressionDataDescriptor {
+    public CF4(string resourceName) : base(resourceName) { }
     public override string Name { get { return "CF4"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/MibaFrictionRegressionInstanceProvider.cs	(revision 15855)
@@ -47,13 +47,13 @@
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       List<ResourceRegressionDataDescriptor> descriptorList = new List<ResourceRegressionDataDescriptor>();
-      descriptorList.Add(new CF1() { ResourceName = "CF1.csv" });
-      descriptorList.Add(new CF2() { ResourceName = "CF2.csv" });
-      descriptorList.Add(new CF3() { ResourceName = "CF3.csv" });
-      descriptorList.Add(new CF4() { ResourceName = "CF4.csv" });
-      descriptorList.Add(new NvhRating() { ResourceName = "NvhRating.csv" });
-      descriptorList.Add(new Temp1() { ResourceName = "Temp1.csv" });
-      descriptorList.Add(new Temp2() { ResourceName = "Temp2.csv" });
-      descriptorList.Add(new Wear1() { ResourceName = "Wear1.csv" });
-      descriptorList.Add(new Wear2() { ResourceName = "Wear2.csv" });
+      descriptorList.Add(new CF1("CF1.csv"));
+      descriptorList.Add(new CF2("CF2.csv"));
+      descriptorList.Add(new CF3("CF3.csv"));
+      descriptorList.Add(new CF4("CF4.csv"));
+      descriptorList.Add(new NvhRating("NvhRating.csv"));
+      descriptorList.Add(new Temp1("Temp1.csv"));
+      descriptorList.Add(new Temp2("Temp2.csv"));
+      descriptorList.Add(new Wear1("Wear1.csv"));
+      descriptorList.Add(new Wear2("Wear2.csv"));
 
       return descriptorList;
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class NvhRating : ResourceRegressionDataDescriptor {
+    public NvhRating(string resourceName) : base(resourceName) { }
     public override string Name { get { return "NvhRating"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Temp1 : ResourceRegressionDataDescriptor {
+    public Temp1(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Temp1"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Temp2 : ResourceRegressionDataDescriptor {
+    public Temp2(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Temp2"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Wear1 : ResourceRegressionDataDescriptor {
+    public Wear1(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Wear1"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Wear2 : ResourceRegressionDataDescriptor {
+    public Wear2(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Wear2"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class ChemicalOne : ResourceRegressionDataDescriptor {
+    public ChemicalOne(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Chemical-I"; } }
     public override string Description { get { return ""; } }
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs	(revision 15855)
@@ -22,4 +22,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Housing : ResourceRegressionDataDescriptor {
+    public Housing(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Housing"; } }
     public override string Description { get { return ""; } }
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Powermeter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Powermeter.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Powermeter.cs	(revision 15855)
@@ -24,4 +24,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Powermeter : ResourceRegressionDataDescriptor {
+    public Powermeter(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Powermeter"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 15855)
@@ -47,9 +47,9 @@
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
       List<ResourceRegressionDataDescriptor> descriptorList = new List<ResourceRegressionDataDescriptor>();
-      descriptorList.Add(new ChemicalOne() { ResourceName = "Chemical-I.csv" });
-      descriptorList.Add(new Housing() { ResourceName = "Housing.csv" });
-      descriptorList.Add(new Tower() { ResourceName = "Tower.txt" });
-      descriptorList.Add(new Powermeter() { ResourceName = "Powermeter.txt" });
-      descriptorList.Add(new SARCOS() { ResourceName = "SARCOS - Inverse Dynamics.txt" });
+      descriptorList.Add(new ChemicalOne("Chemical-I.csv"));
+      descriptorList.Add(new Housing("Housing.csv"));
+      descriptorList.Add(new Tower("Tower.txt"));
+      descriptorList.Add(new Powermeter("Powermeter.txt"));
+      descriptorList.Add(new SARCOS("SARCOS - Inverse Dynamics.txt"));
       return descriptorList;
     }
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/SARCOS.cs	(revision 15855)
@@ -24,4 +24,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class SARCOS : ResourceRegressionDataDescriptor {
+    public SARCOS(string resourceName) : base(resourceName) { }
     public override string Name { get { return "SARCOS - Inverse Dynamics"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs	(revision 15855)
@@ -24,4 +24,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Tower : ResourceRegressionDataDescriptor {
+    public Tower(string resourceName) : base(resourceName) { }
     public override string Name { get { return "Tower"; } }
     public override string Description {
Index: /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionDataDescriptor.cs
===================================================================
--- /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionDataDescriptor.cs	(revision 15854)
+++ /trunk/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionDataDescriptor.cs	(revision 15855)
@@ -25,5 +25,9 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public abstract class ResourceRegressionDataDescriptor : RegressionDataDescriptor {
-    public string ResourceName { get; set; }
+    public ResourceRegressionDataDescriptor(string resourceName) {
+      ResourceName = resourceName;
+    }
+
+    public string ResourceName { get; private set; }
 
     public bool CheckVariableNames(IEnumerable<string> VariableNames) {