Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs	(revision 15864)
@@ -48,5 +48,4 @@
       this.exportFileDialog = new System.Windows.Forms.SaveFileDialog();
       this.btnSimplify = new System.Windows.Forms.Button();
-      this.transformModelButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -61,5 +60,4 @@
       this.flowLayoutPanel.Controls.Add(this.btnSimplify);
       this.flowLayoutPanel.Controls.Add(this.exportButton);
-      this.flowLayoutPanel.Controls.Add(this.transformModelButton);
       // 
       // btnSimplify
@@ -91,18 +89,4 @@
       this.toolTip.SetToolTip(this.exportButton, "Exports the symbolic regression solution to Excel.");
       // 
-      // transformModelButton
-      // 
-      this.transformModelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)));
-      this.transformModelButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Event;
-      this.transformModelButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
-      this.transformModelButton.Name = "transformModelButton";
-      this.transformModelButton.Size = new System.Drawing.Size(135, 24);
-      this.transformModelButton.TabIndex = 9;
-      this.transformModelButton.Text = "Backtransform Model";
-      this.transformModelButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
-      this.transformModelButton.UseVisualStyleBackColor = true;
-      this.transformModelButton.Click += new System.EventHandler(this.transformModelButton_Click);
-      this.toolTip.SetToolTip(this.transformModelButton, "Backtransform model based on the stored transformations.");
-      // 
       // SymbolicRegressionSolutionView
       // 
@@ -123,5 +107,4 @@
     protected System.Windows.Forms.Button exportButton;
     protected System.Windows.Forms.Button btnSimplify;
-    protected System.Windows.Forms.Button transformModelButton;
   }
 }
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.cs	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.cs	(revision 15864)
@@ -45,6 +45,4 @@
       btnSimplify.Enabled = Content != null && !Locked && Content.ProblemData.TrainingIndices.Any(); // simplification is only possible if there are trainings samples
       exportButton.Enabled = Content != null && !Locked;
-      transformModelButton.Visible = Content != null && Content.ProblemData.Transformations.Any();
-      transformModelButton.Enabled = Content != null && !Locked;
     }
 
@@ -68,17 +66,4 @@
       }
     }
-
-    private void transformModelButton_Click(object sender, EventArgs e) {
-      var mapper = new TransformationToSymbolicTreeMapper();
-      var transformator = new SymbolicExpressionTreeBacktransformator(mapper);
-
-      var transformations = Content.ProblemData.Transformations;
-      var targetVar = Content.ProblemData.TargetVariable;
-
-      var transformedModel = (ISymbolicRegressionModel)transformator.Backtransform(Content.Model, transformations, targetVar);
-      var transformedSolution = new SymbolicRegressionSolution(transformedModel, (IRegressionProblemData)Content.ProblemData.Clone());
-
-      MainFormManager.MainForm.ShowContent(transformedSolution);
-    }
   }
 }
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 15864)
@@ -310,6 +310,4 @@
     <Compile Include="Symbols\VariableConditionTreeNode.cs" />
     <Compile Include="Symbols\VariableTreeNode.cs" />
-    <Compile Include="Transformations\SymbolicExpressionTreeBacktransformator.cs" />
-    <Compile Include="Transformations\TransformationToSymbolicTreeMapper.cs" />
     <Compile Include="TreeMatching\SymbolicExpressionTreeBottomUpSimilarityCalculator.cs" />
     <Compile Include="TreeMatching\SymbolicExpressionTreeCanonicalSorter.cs" />
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 15864)
@@ -19,4 +19,5 @@
  */
 #endregion
+
 
 
@@ -46,4 +47,5 @@
     /// </summary>
     private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RegressionSolutionView));
       this.TransformButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
@@ -72,9 +74,13 @@
       // TransformButton
       // 
+      this.TransformButton.AutoSize = true;
+      this.TransformButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
       this.TransformButton.Location = new System.Drawing.Point(117, 3);
       this.TransformButton.Name = "TransformButton";
-      this.TransformButton.Size = new System.Drawing.Size(75, 23);
+      this.TransformButton.Size = new System.Drawing.Size(108, 23);
       this.TransformButton.TabIndex = 1;
-      this.TransformButton.Text = "Reverse Transformations";
+      this.TransformButton.Text = "Transform Back";
+      this.TransformButton.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
+      this.toolTip.SetToolTip(this.TransformButton, "TODO: Backtransform model based on the stored transformations.");
       this.TransformButton.UseVisualStyleBackColor = true;
       this.TransformButton.Click += new System.EventHandler(this.transformButton_Click);
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 15864)
@@ -22,4 +22,5 @@
 using System.Linq;
 using System.Windows.Forms;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
@@ -31,4 +32,5 @@
     public RegressionSolutionView() {
       InitializeComponent();
+      TransformButton.Image = VSImageLibrary.Event;
       flowLayoutPanel.Controls.Add(TransformButton);
     }
@@ -41,4 +43,5 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
+      TransformButton.Enabled = Content != null;
       TransformButton.Visible = Content != null && Content.ProblemData.Transformations.Any();
     }
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TransformedRegressionSolutionView.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TransformedRegressionSolutionView.cs	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/TransformedRegressionSolutionView.cs	(revision 15864)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Problems.DataAnalysis.Views {
   [View("Transformation Solution View")]
-  [Content(typeof(TransformedRegressionSolution), true)]
+  [Content(typeof(TransformedRegressionSolution), false)]
   public partial class TransformedRegressionSolutionView : RegressionSolutionView {
 
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 15864)
@@ -242,5 +242,4 @@
     <Compile Include="Interfaces\IDependencyCalculator.cs" />
     <Compile Include="Interfaces\ITransformation.cs" />
-    <Compile Include="Interfaces\ITransformationMapper.cs" />
     <Compile Include="Interfaces\Regression\ITransformedRegressionModel.cs" />
     <Compile Include="Interfaces\Regression\ITransformedRegressionSolution.cs" />
Index: /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/TransformedRegressionModel.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/TransformedRegressionModel.cs	(revision 15863)
+++ /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/TransformedRegressionModel.cs	(revision 15864)
@@ -75,4 +75,5 @@
     // problemData in original data range
     public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+      // TODO: specialized views for the original solution type are lost (RandomForestSolutionView, ...)
       return new TransformedRegressionSolution(this, new RegressionProblemData(problemData));
     }
Index: anches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/ITransformationMapper.cs
===================================================================
--- /branches/2906_Transformations/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/ITransformationMapper.cs	(revision 15863)
+++ 	(revision )
@@ -1,31 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-
-using System;
-
-namespace HeuristicLab.Problems.DataAnalysis {
-  [Obsolete]
-  public interface ITransformationMapper<out T> {
-    T GenerateModel(ITransformation transformation);
-    T GenerateInverseModel(ITransformation transformation);
-  }
-}